diff --git a/hardware/nvidia/platform/t19x/jakku/kernel-dts/common/tegra194-camera-jakku-rbpcv2-imx219.dtsi b/hardware/nvidia/platform/t19x/jakku/kernel-dts/common/tegra194-camera-jakku-rbpcv2-imx219.dtsi
index 1f3898243..808d877cc 100644
--- a/hardware/nvidia/platform/t19x/jakku/kernel-dts/common/tegra194-camera-jakku-rbpcv2-imx219.dtsi
+++ b/hardware/nvidia/platform/t19x/jakku/kernel-dts/common/tegra194-camera-jakku-rbpcv2-imx219.dtsi
@@ -17,35 +17,206 @@
 
 #include "tegra194-camera-rbpcv2-imx219.dtsi"
 
-#define CAM0_PWDN	TEGRA194_MAIN_GPIO(P, 4)
+//#define CAM0_PWDN	TEGRA194_MAIN_GPIO(P, 4)
+#define CAM0_PWDN	TEGRA194_MAIN_GPIO(T, 2)
 #define CAM1_PWDN	TEGRA194_MAIN_GPIO(P, 5)
-#define CAM_I2C_MUX 	TEGRA194_AON_GPIO(CC, 3)
+//#define CAM_I2C_MUX 	TEGRA194_AON_GPIO(CC, 3)
+//#define CAM0_RST_L	TEGRA194_MAIN_GPIO(H, 3)
+//#define CAM0_PWDN	TEGRA194_MAIN_GPIO(H, 6)
+//#define CAM1_RST_L	TEGRA194_MAIN_GPIO(T, 6)
+//#define CAM1_PWDN	TEGRA194_MAIN_GPIO(T, 5)
 
 / {
-	cam_i2cmux{
-		compatible = "i2c-mux-gpio";
-		#address-cells = <1>;
-		#size-cells = <0>;
-		i2c-parent = <&cam_i2c>;
-		mux-gpios = <&tegra_aon_gpio CAM_I2C_MUX GPIO_ACTIVE_HIGH>;
-		i2c@0 {
-			reg = <0>;
-			#address-cells = <1>;
-			#size-cells = <0>;
-			rbpcv2_imx219_a@10 {
-				reset-gpios = <&tegra_main_gpio CAM0_PWDN GPIO_ACTIVE_HIGH>;
-			};
+		p2822_avdd_cam_2v8: regulator@107 {
+			compatible = "regulator-fixed";
+			reg = <107>;
+			regulator-name = "avdd-cam-2v8";
+			regulator-min-microvolt = <2800000>;
+			regulator-max-microvolt = <2800000>;
+			gpio = <&tegra_main_gpio TEGRA194_MAIN_GPIO(N, 0) 0>;
+			enable-active-high;
+		};
+		p2822_vdd_1v8_cvb: regulator@102 {
+			compatible = "regulator-fixed";
+			reg = <102>;
+			regulator-name = "vdd-1v8-cvb";
+			regulator-min-microvolt = <1800000>;
+			regulator-max-microvolt = <1800000>;
 		};
-		i2c@1 {
-			reg = <1>;
-			#address-cells = <1>;
-			#size-cells = <0>;
-			rbpcv2_imx219_c@10 {
-				reset-gpios = <&tegra_main_gpio CAM1_PWDN GPIO_ACTIVE_HIGH>;
+	i2c@3180000{
+		tca9546_70: tca9546@70 {
+                        compatible = "nxp,pca9546";
+                        reg = <0x70>;
+                        #address-cells = <1>;
+                        #size-cells = <0>;
+                        skip_mux_detect;
+                        vif-supply = <&p3509_vdd_1v8_cvb>;
+                        /*vcc_lp = "vif";*/
+
+                        i2c@0 {
+                                reg = <0>;
+                                i2c-mux,deselect-on-exit;
+                                #address-cells = <1>;
+                                #size-cells = <0>;
+                        };
+#if 1
+                        i2c@1 {
+                                reg = <1>;
+                                i2c-mux,deselect-on-exit;
+                                #address-cells = <1>;
+                                #size-cells = <0>;
+                        };
+#endif
+                };
+		tca9546@70 {
+			i2c@0 {
+				ov5693_a@30 {
+					/* Define any required hw resources needed by driver */
+					/* ie. clocks, io pins, power sources */
+					/* mclk-index indicates the index of the */
+					/* mclk-name with in the clock-names array */
+
+					clocks = <&bpmp_clks TEGRA194_CLK_EXTPERIPH1>,
+							 <&bpmp_clks TEGRA194_CLK_PLLP_OUT0>;
+					clock-names = "extperiph1", "pllp_grtba";
+					mclk = "extperiph1";
+					clock-frequency = <24000000>;
+					reset-gpios = <&tegra_main_gpio CAM0_PWDN GPIO_ACTIVE_HIGH>;
+					//pwdn-gpios = <&tegra_main_gpio CAM0_PWDN GPIO_ACTIVE_HIGH>;
+					vana-supply = <&p3509_avdd_cam_2v8>;
+					vif-supply = <&p3509_vdd_1v8_cvb>;
+				};
+				ov5693_a@31 {
+					/* Define any required hw resources needed by driver */
+					/* ie. clocks, io pins, power sources */
+					/* mclk-index indicates the index of the */
+					/* mclk-name with in the clock-names array */
+
+					clocks = <&bpmp_clks TEGRA194_CLK_EXTPERIPH1>,
+							 <&bpmp_clks TEGRA194_CLK_PLLP_OUT0>;
+					clock-names = "extperiph1", "pllp_grtba";
+					mclk = "extperiph1";
+					clock-frequency = <24000000>;
+					reset-gpios = <&tegra_main_gpio CAM0_PWDN GPIO_ACTIVE_HIGH>;
+					//pwdn-gpios = <&tegra_main_gpio CAM0_PWDN GPIO_ACTIVE_HIGH>;
+					vana-supply = <&p3509_avdd_cam_2v8>;
+					vif-supply = <&p3509_vdd_1v8_cvb>;
+				};
+				ov5693_a@32 {
+					/* Define any required hw resources needed by driver */
+					/* ie. clocks, io pins, power sources */
+					/* mclk-index indicates the index of the */
+					/* mclk-name with in the clock-names array */
+
+					clocks = <&bpmp_clks TEGRA194_CLK_EXTPERIPH1>,
+							 <&bpmp_clks TEGRA194_CLK_PLLP_OUT0>;
+					clock-names = "extperiph1", "pllp_grtba";
+					mclk = "extperiph1";
+					clock-frequency = <24000000>;
+					reset-gpios = <&tegra_main_gpio CAM0_PWDN GPIO_ACTIVE_HIGH>;
+					//pwdn-gpios = <&tegra_main_gpio CAM0_PWDN GPIO_ACTIVE_HIGH>;
+					vana-supply = <&p3509_avdd_cam_2v8>;
+					vif-supply = <&p3509_vdd_1v8_cvb>;
+				};
+				ov5693_a@33 {
+					/* Define any required hw resources needed by driver */
+					/* ie. clocks, io pins, power sources */
+					/* mclk-index indicates the index of the */
+					/* mclk-name with in the clock-names array */
+
+					clocks = <&bpmp_clks TEGRA194_CLK_EXTPERIPH1>,
+							 <&bpmp_clks TEGRA194_CLK_PLLP_OUT0>;
+					clock-names = "extperiph1", "pllp_grtba";
+					mclk = "extperiph1";
+					clock-frequency = <24000000>;
+					reset-gpios = <&tegra_main_gpio CAM0_PWDN GPIO_ACTIVE_HIGH>;
+					//pwdn-gpios = <&tegra_main_gpio CAM0_PWDN GPIO_ACTIVE_HIGH>;
+					vana-supply = <&p3509_avdd_cam_2v8>;
+					vif-supply = <&p3509_vdd_1v8_cvb>;
+				};
+			};
+#if 1
+			i2c@1 {
+				ov5693_c@36 {
+					/* Define any required hw resources needed by driver */
+					/* ie. clocks, io pins, power sources */
+					/* mclk-index indicates the index of the */
+					/* mclk-name with in the clock-names array */
+
+					clocks = <&bpmp_clks TEGRA194_CLK_EXTPERIPH1>,
+							 <&bpmp_clks TEGRA194_CLK_PLLP_OUT0>;
+					clock-names = "extperiph1", "pllp_grtba";
+					mclk = "extperiph1";
+					clock-frequency = <24000000>;
+					reset-gpios = <&tegra_main_gpio CAM1_PWDN GPIO_ACTIVE_HIGH>;
+					//pwdn-gpios = <&tegra_main_gpio CAM0_PWDN GPIO_ACTIVE_HIGH>;
+					vana-supply = <&p3509_avdd_cam_2v8>;
+					vif-supply = <&p3509_vdd_1v8_cvb>;
+				};
+				ov5693_c@37 {
+					/* Define any required hw resources needed by driver */
+					/* ie. clocks, io pins, power sources */
+					/* mclk-index indicates the index of the */
+					/* mclk-name with in the clock-names array */
+
+					clocks = <&bpmp_clks TEGRA194_CLK_EXTPERIPH1>,
+							 <&bpmp_clks TEGRA194_CLK_PLLP_OUT0>;
+					clock-names = "extperiph1", "pllp_grtba";
+					mclk = "extperiph1";
+					clock-frequency = <24000000>;
+					reset-gpios = <&tegra_main_gpio CAM1_PWDN GPIO_ACTIVE_HIGH>;
+					//pwdn-gpios = <&tegra_main_gpio CAM0_PWDN GPIO_ACTIVE_HIGH>;
+					vana-supply = <&p3509_avdd_cam_2v8>;
+					vif-supply = <&p3509_vdd_1v8_cvb>;
+				};
+				ov5693_c@38 {
+					/* Define any required hw resources needed by driver */
+					/* ie. clocks, io pins, power sources */
+					/* mclk-index indicates the index of the */
+					/* mclk-name with in the clock-names array */
+
+					clocks = <&bpmp_clks TEGRA194_CLK_EXTPERIPH1>,
+							 <&bpmp_clks TEGRA194_CLK_PLLP_OUT0>;
+					clock-names = "extperiph1", "pllp_grtba";
+					mclk = "extperiph1";
+					clock-frequency = <24000000>;
+					reset-gpios = <&tegra_main_gpio CAM1_PWDN GPIO_ACTIVE_HIGH>;
+					//pwdn-gpios = <&tegra_main_gpio CAM0_PWDN GPIO_ACTIVE_HIGH>;
+					vana-supply = <&p3509_avdd_cam_2v8>;
+					vif-supply = <&p3509_vdd_1v8_cvb>;
+				};
+				ov5693_c@39 {
+					/* Define any required hw resources needed by driver */
+					/* ie. clocks, io pins, power sources */
+					/* mclk-index indicates the index of the */
+					/* mclk-name with in the clock-names array */
+
+					clocks = <&bpmp_clks TEGRA194_CLK_EXTPERIPH1>,
+							 <&bpmp_clks TEGRA194_CLK_PLLP_OUT0>;
+					clock-names = "extperiph1", "pllp_grtba";
+					mclk = "extperiph1";
+					clock-frequency = <24000000>;
+					reset-gpios = <&tegra_main_gpio CAM1_PWDN GPIO_ACTIVE_HIGH>;
+					//pwdn-gpios = <&tegra_main_gpio CAM0_PWDN GPIO_ACTIVE_HIGH>;
+					vana-supply = <&p3509_avdd_cam_2v8>;
+					vif-supply = <&p3509_vdd_1v8_cvb>;
+				};
+			
 			};
+#endif
 		};
 	};
-
+	tegra-camera-platform {
+		/**
+		* tpg_max_iso = <>;
+		* Max iso bw for 6 streams of tpg
+		* streams * nvcsi_freq * PG_bitrate / RG10 * BPP
+		* 6 * 102Mhz * 32 bits/ 10 bits * 2 Bps
+		* = 3916.8 MBps
+		*/
+		tpg_max_iso = <3916800>;
+	};
+#if 1
 	gpio@2200000 {
 		camera-control-output-low {
 			gpio-hog;
@@ -54,4 +225,16 @@
 			label = "cam0-pwdn","cam1-pwdn";
 		};
 	};
+#else
+	gpio@2200000 {
+		camera-control-output-low {
+			gpio-hog;
+			output-low;
+			gpios = <CAM0_RST_L 0 CAM0_PWDN 0
+				 CAM1_RST_L 0 CAM1_PWDN 0>;
+			label = "cam0-rst", "cam0-pwdn",
+				"cam1-rst", "cam1-pwdn";
+		};
+	};
+#endif
 };
diff --git a/hardware/nvidia/platform/t19x/jakku/kernel-dts/common/tegra194-camera-rbpcv2-imx219.dtsi b/hardware/nvidia/platform/t19x/jakku/kernel-dts/common/tegra194-camera-rbpcv2-imx219.dtsi
index adae089dc..d4cd7a4d6 100644
--- a/hardware/nvidia/platform/t19x/jakku/kernel-dts/common/tegra194-camera-rbpcv2-imx219.dtsi
+++ b/hardware/nvidia/platform/t19x/jakku/kernel-dts/common/tegra194-camera-rbpcv2-imx219.dtsi
@@ -845,52 +3892,163 @@
 		* isp_bw_margin_pct = <>;
 		* Isp bandwidth margin in percentage
 		*/
-		num_csi_lanes = <4>;
-		max_lane_speed = <1500000>;
+		num_csi_lanes = <16>;
+		//max_lane_speed = <1500000>; //delete by wyf
+		max_lane_speed = <1600000>; //add by wyf
 		min_bits_per_pixel = <10>;
 		vi_peak_byte_per_pixel = <2>;
 		vi_bw_margin_pct = <25>;
-		max_pixel_rate = <240000>;
+		max_pixel_rate = <160000>;
 		isp_peak_byte_per_pixel = <5>;
 		isp_bw_margin_pct = <25>;
 
 		/**
-		 * The general guideline for naming badge_info contains 3 parts, and is as follows,
-		 * The first part is the camera_board_id for the module; if the module is in a FFD
-		 * platform, then use the platform name for this part.
-		 * The second part contains the position of the module, ex. "rear" or "front".
-		 * The third part contains the last 6 characters of a part number which is found
-		 * in the module's specsheet from the vendor.
-		 */
+		* The general guideline for naming badge_info contains 3 parts, and is as follows,
+		* The first part is the camera_board_id for the module; if the module is in a FFD
+		* platform, then use the platform name for this part.
+		* The second part contains the position of the module, ex. “rear” or “front”.
+		* The third part contains the last 6 characters of a part number which is found
+		* in the module's specsheet from the vender.
+		*/
 		modules {
-			cam_module0: module0 {
-				badge = "jakku_front_RBP194";
+			module0 {
+				badge = "e3326_top_P5V27C";
+				position = "top";
+				orientation = "0";
+				drivernode0 {
+					/* Declare PCL support driver (classically known as guid)  */
+					pcl_id = "v4l2_sensor";
+					/* Driver v4l2 device name */
+					devname = "ov5693 30-0030";
+					/* Declare the device-tree hierarchy to driver instance */
+					proc-device-tree = "/proc/device-tree/i2c@3180000/tca9546@70/i2c@0/ov5693_a@30";
+				};
+				drivernode1 {
+					/* Declare PCL support driver (classically known as guid)  */
+					pcl_id = "v4l2_lens";
+				};
+			};
+			module1 {
+				badge = "e3326_front_P5V27C";
 				position = "front";
+				orientation = "0";
+				drivernode0 {
+					/* Declare PCL support driver (classically known as guid)  */
+					pcl_id = "v4l2_sensor";
+					/* Driver v4l2 device name */
+					devname = "ov5693 30-0031";
+					/* Declare the device-tree hierarchy to driver instance */
+					proc-device-tree = "/proc/device-tree/i2c@3180000/tca9546@70/i2c@0/ov5693_a@31";
+				};
+				drivernode1 {
+					/* Declare PCL support driver (classically known as guid)  */
+					pcl_id = "v4l2_lens";
+				};
+			};
+			module2 {
+				badge = "e3326_left_P5V27C";
+				position = "left";
+				orientation = "0";
+				drivernode0 {
+					/* Declare PCL support driver (classically known as guid)  */
+					pcl_id = "v4l2_sensor";
+					/* Driver v4l2 device name */
+					devname = "ov5693 30-0032";
+					/* Declare the device-tree hierarchy to driver instance */
+					proc-device-tree = "/proc/device-tree/i2c@3180000/tca9546@70/i2c@0/ov5693_a@32";
+				};
+				drivernode1 {
+					/* Declare PCL support driver (classically known as guid)  */
+					pcl_id = "v4l2_lens";
+				};
+			};
+			module3 {
+				badge = "e3326_right_P5V27C";
+				position = "right";
+				orientation = "0";
+				drivernode0 {
+					/* Declare PCL support driver (classically known as guid)  */
+					pcl_id = "v4l2_sensor";
+					/* Driver v4l2 device name */
+					devname = "ov5693 30-0033";
+					/* Declare the device-tree hierarchy to driver instance */
+					proc-device-tree = "/proc/device-tree/i2c@3180000/tca9546@70/i2c@0/ov5693_a@33";
+				};
+				drivernode1 {
+					/* Declare PCL support driver (classically known as guid)  */
+					pcl_id = "v4l2_lens";
+				};
+			};
+#if 1
+			module4 {
+				badge = "e3326_bottom_P5V27C";
+				position = "bottom";
+				orientation = "1";
+				drivernode0 {
+					/* Declare PCL support driver (classically known as guid)  */
+					pcl_id = "v4l2_sensor";
+					/* Driver v4l2 device name */
+					devname = "ov5693 31-0036";
+					/* Declare the device-tree hierarchy to driver instance */
+					proc-device-tree = "/proc/device-tree/i2c@3180000/tca9546@70/i2c@1/ov5693_c@36";
+				};
+				drivernode1 {
+					/* Declare PCL support driver (classically known as guid)  */
+					pcl_id = "v4l2_lens";
+				};
+			};
+			module5 {
+				badge = "e3326_center_P5V27C";
+				position = "center";
+				orientation = "1";
+				drivernode0 {
+					/* Declare PCL support driver (classically known as guid)  */
+					pcl_id = "v4l2_sensor";
+					/* Driver v4l2 device name */
+					devname = "ov5693 31-0037";
+					/* Declare the device-tree hierarchy to driver instance */
+					proc-device-tree = "/proc/device-tree/i2c@3180000/tca9546@70/i2c@1/ov5693_c@37";
+				};
+				drivernode1 {
+					/* Declare PCL support driver (classically known as guid)  */
+					pcl_id = "v4l2_lens";
+				};
+			};
+			module6 {
+				badge = "e3326_left_P5V27C";
+				position = "left";
 				orientation = "1";
-				cam_module0_drivernode0: drivernode0 {
+				drivernode0 {
+					/* Declare PCL support driver (classically known as guid)  */
 					pcl_id = "v4l2_sensor";
-					devname = "imx219 9-0010";
-					proc-device-tree = "/proc/device-tree/cam_i2cmux/i2c@0/rbpcv2_imx219_a@10";
+					/* Driver v4l2 device name */
+					devname = "ov5693 31-0038";
+					/* Declare the device-tree hierarchy to driver instance */
+					proc-device-tree = "/proc/device-tree/i2c@3180000/tca9546@70/i2c@1/ov5693_c@38";
 				};
-				cam_module0_drivernode1: drivernode1 {
+				drivernode1 {
+					/* Declare PCL support driver (classically known as guid)  */
 					pcl_id = "v4l2_lens";
-					proc-device-tree = "/proc/device-tree/lens_imx219@RBPCV2/";
 				};
 			};
-			cam_module1: module1 {
-				badge = "jakku_rear_RBP194";
-				position = "rear";
+			module7 {
+				badge = "e3326_right_P5V27C";
+				position = "right";
 				orientation = "1";
-				cam_module1_drivernode0: drivernode0 {
+				drivernode0 {
+					/* Declare PCL support driver (classically known as guid)  */
 					pcl_id = "v4l2_sensor";
-					devname = "imx219 10-0010";
-					proc-device-tree = "/proc/device-tree/cam_i2cmux/i2c@1/rbpcv2_imx219_c@10";
+					/* Driver v4l2 device name */
+					devname = "ov5693 31-0039";
+					/* Declare the device-tree hierarchy to driver instance */
+					proc-device-tree = "/proc/device-tree/i2c@3180000/tca9546@70/i2c@1/ov5693_c@39";
 				};
-				cam_module1_drivernode1: drivernode1 {
+				drivernode1 {
+					/* Declare PCL support driver (classically known as guid)  */
 					pcl_id = "v4l2_lens";
-					proc-device-tree = "/proc/device-tree/lens_imx219@RBPCV2/";
 				};
 			};
+#endif
 		};
 	};
 };
diff --git a/hardware/nvidia/platform/t19x/jakku/kernel-dts/common/tegra194-p3509-0000-a00.dtsi b/hardware/nvidia/platform/t19x/jakku/kernel-dts/common/tegra194-p3509-0000-a00.dtsi
index 6f411e3c1..6ac4d2681 100644
--- a/hardware/nvidia/platform/t19x/jakku/kernel-dts/common/tegra194-p3509-0000-a00.dtsi
+++ b/hardware/nvidia/platform/t19x/jakku/kernel-dts/common/tegra194-p3509-0000-a00.dtsi
@@ -16,7 +16,7 @@
 #include "tegra194-p3509-disp.dtsi"
 #include "tegra194-audio-p3668.dtsi"
 #include "tegra194-super-module-e2614-p3509.dtsi"
-#include "tegra194-camera-jakku-rbpcv3-imx477.dtsi"
+//#include "tegra194-camera-jakku-rbpcv3-imx477.dtsi"
 #include "tegra194-camera-jakku-rbpcv2-imx219.dtsi"
 / {
 	gpio-keys {
diff --git a/kernel/nvidia/drivers/media/i2c/Makefile b/kernel/nvidia/drivers/media/i2c/Makefile
index f8f6c3ba0..c5bd924f6 100644
--- a/kernel/nvidia/drivers/media/i2c/Makefile
+++ b/kernel/nvidia/drivers/media/i2c/Makefile
@@ -11,7 +11,8 @@ obj-$(CONFIG_NV_VIDEO_IMX268) += nv_imx268.o
 obj-$(CONFIG_NV_VIDEO_IMX274) += nv_imx274.o
 obj-$(CONFIG_NV_VIDEO_IMX318) += nv_imx318.o
 obj-$(CONFIG_NV_VIDEO_LC898212) += nv_lc898212.o
-obj-$(CONFIG_NV_VIDEO_OV5693) += nv_ov5693.o
+#obj-$(CONFIG_NV_VIDEO_OV5693) += nv_ov5693.o
+obj-y += nv_ov5693.o
 obj-$(CONFIG_NV_VIDEO_OV9281) += nv_ov9281.o
 obj-$(CONFIG_NV_VIDEO_OV10823) += nv_ov10823.o
 obj-$(CONFIG_NV_VIDEO_OV23850) += nv_ov23850.o
diff --git a/kernel/nvidia/drivers/media/i2c/nv_ov5693.c b/kernel/nvidia/drivers/media/i2c/nv_ov5693.c
index 3b6797a85..62581008e 100644
--- a/kernel/nvidia/drivers/media/i2c/nv_ov5693.c
+++ b/kernel/nvidia/drivers/media/i2c/nv_ov5693.c
@@ -79,7 +79,7 @@ struct ov5693 {
 };
 
 static struct regmap_config ov5693_regmap_config = {
-	.reg_bits = 16,
+	.reg_bits = 8,
 	.val_bits = 8,
 };
 
@@ -164,7 +164,7 @@ static int ov5693_write_table(struct ov5693 *priv,
 					 OV5693_TABLE_WAIT_MS,
 					 OV5693_TABLE_END);
 }
-
+/*
 static void ov5693_gpio_set(struct camera_common_data *s_data,
 			    unsigned int gpio, int val)
 {
@@ -179,10 +179,11 @@ static void ov5693_gpio_set(struct camera_common_data *s_data,
 			gpio_set_value(gpio, val);
 	}
 }
-
+*/
 static int ov5693_power_on(struct camera_common_data *s_data)
 {
 	int err = 0;
+#if 0
 	struct camera_common_power_rail *pw = s_data->power;
 	struct camera_common_pdata *pdata = s_data->pdata;
 	struct device *dev = s_data->dev;
@@ -239,11 +240,14 @@ ov5693_iovdd_fail:
 ov5693_avdd_fail:
 	dev_err(dev, "%s failed.\n", __func__);
 	return -ENODEV;
+#endif 
+	return err;
 }
 
 static int ov5693_power_off(struct camera_common_data *s_data)
 {
-	int err = 0;
+	//int err = 0;
+#if 0
 	struct camera_common_power_rail *pw = s_data->power;
 	struct device *dev = s_data->dev;
 	struct camera_common_pdata *pdata = s_data->pdata;
@@ -280,11 +284,13 @@ static int ov5693_power_off(struct camera_common_data *s_data)
 
 power_off_done:
 	pw->state = SWITCH_OFF;
+#endif
 	return 0;
 }
 
 static int ov5693_power_put(struct tegracam_device *tc_dev)
 {
+#if 0
 	struct camera_common_data *s_data = tc_dev->s_data;
 	struct camera_common_power_rail *pw = s_data->power;
 	struct camera_common_pdata *pdata = s_data->pdata;
@@ -301,7 +307,7 @@ static int ov5693_power_put(struct tegracam_device *tc_dev)
 		if (gpio_is_valid(pw->reset_gpio))
 			gpio_free(pw->reset_gpio);
 	}
-
+#endif
 	return 0;
 }
 
@@ -337,7 +343,7 @@ static int ov5693_power_get(struct tegracam_device *tc_dev)
 		} else
 			clk_set_parent(pw->mclk, parent);
 	}
-
+#if 0
 	/* analog 2.8v */
 	err |= camera_common_regulator_get(dev,
 			&pw->avdd, pdata->regulators.avdd);
@@ -345,10 +351,12 @@ static int ov5693_power_get(struct tegracam_device *tc_dev)
 	err |= camera_common_regulator_get(dev,
 			&pw->iovdd, pdata->regulators.iovdd);
 
+
 	if (!err) {
 		pw->reset_gpio = pdata->reset_gpio;
 		pw->pwdn_gpio = pdata->pwdn_gpio;
 	}
+#endif
 	if (pdata->use_cam_gpio) {
 		err = cam_gpio_register(dev, pw->pwdn_gpio);
 		if (err)
@@ -634,7 +642,7 @@ static int ov5693_fill_string_ctrl(struct tegracam_device *tc_dev,
 	ctrl->p_cur.p_char = ctrl->p_new.p_char;
 	return 0;
 }
-
+#if 0
 static int ov5693_eeprom_device_release(struct ov5693 *priv)
 {
 	int i;
@@ -648,9 +656,10 @@ static int ov5693_eeprom_device_release(struct ov5693 *priv)
 
 	return 0;
 }
-
+#endif
 static int ov5693_eeprom_device_init(struct ov5693 *priv)
 {
+#if 0
 	struct camera_common_pdata *pdata =  priv->s_data->pdata;
 	char *dev_name = "eeprom_ov5693";
 	static struct regmap_config eeprom_regmap_config = {
@@ -686,12 +695,13 @@ static int ov5693_eeprom_device_init(struct ov5693 *priv)
 			return err;
 		}
 	}
-
+#endif
 	return 0;
 }
 
 static int ov5693_read_eeprom(struct ov5693 *priv)
 {
+#if 0
 	int err, i;
 
 	for (i = 0; i < OV5693_EEPROM_NUM_BLOCKS; i++) {
@@ -701,13 +711,14 @@ static int ov5693_read_eeprom(struct ov5693 *priv)
 		if (err)
 			return err;
 	}
-
+#endif
 	return 0;
 }
 
 static int ov5693_read_otp_bank(struct ov5693 *priv,
 				u8 *buf, int bank, u16 addr, int size)
 {
+#if 0
 	int err;
 
 	/* sleeps calls in the sequence below are for internal device
@@ -748,6 +759,7 @@ static int ov5693_read_otp_bank(struct ov5693 *priv,
 		priv->streaming = false;
 		mutex_unlock(&priv->streaming_lock);
 	}
+#endif
 
 	return 0;
 }
@@ -881,6 +893,7 @@ error:
 
 static int ov5693_set_mode(struct tegracam_device *tc_dev)
 {
+#if 0
 	struct ov5693 *priv = (struct ov5693 *)tegracam_get_privdata(tc_dev);
 	struct camera_common_data *s_data = tc_dev->s_data;
 	int err;
@@ -891,7 +904,7 @@ static int ov5693_set_mode(struct tegracam_device *tc_dev)
 	err = ov5693_write_table(priv, mode_table[s_data->mode_prop_idx]);
 	if (err)
 		return err;
-
+#endif
 	return 0;
 }
 
@@ -902,10 +915,10 @@ static int ov5693_start_streaming(struct tegracam_device *tc_dev)
 	struct camera_common_pdata *pdata = s_data->pdata;
 	struct device *dev = s_data->dev;
 	int err;
-	u8 val;
+	//u8 val;
 
 	mutex_lock(&priv->streaming_lock);
-	err = ov5693_write_table(priv, mode_table[OV5693_MODE_START_STREAM]);
+	err = 0;//ov5693_write_table(priv, mode_table[OV5693_MODE_START_STREAM]);
 	if (err) {
 		mutex_unlock(&priv->streaming_lock);
 		goto exit;
@@ -914,22 +927,22 @@ static int ov5693_start_streaming(struct tegracam_device *tc_dev)
 		mutex_unlock(&priv->streaming_lock);
 	}
 	if (pdata->v_flip) {
-		ov5693_read_reg(s_data, OV5693_TIMING_REG20, &val);
-		ov5693_write_reg(s_data, OV5693_TIMING_REG20,
-				 val | VERTICAL_FLIP);
+		//ov5693_read_reg(s_data, OV5693_TIMING_REG20, &val);
+		//ov5693_write_reg(s_data, OV5693_TIMING_REG20,
+		//		 val | VERTICAL_FLIP);
 	}
 	if (pdata->h_mirror) {
-		ov5693_read_reg(s_data, OV5693_TIMING_REG21, &val);
-		ov5693_write_reg(s_data, OV5693_TIMING_REG21,
-				 val | HORIZONTAL_MIRROR_MASK);
+		//ov5693_read_reg(s_data, OV5693_TIMING_REG21, &val);
+		//ov5693_write_reg(s_data, OV5693_TIMING_REG21,
+		//		 val | HORIZONTAL_MIRROR_MASK);
 	} else {
-		ov5693_read_reg(s_data, OV5693_TIMING_REG21, &val);
-		ov5693_write_reg(s_data, OV5693_TIMING_REG21,
-				 val & (~HORIZONTAL_MIRROR_MASK));
+		//ov5693_read_reg(s_data, OV5693_TIMING_REG21, &val);
+		//ov5693_write_reg(s_data, OV5693_TIMING_REG21,
+		//		 val & (~HORIZONTAL_MIRROR_MASK));
 	}
-	if (test_mode)
-		err = ov5693_write_table(priv,
-			mode_table[OV5693_MODE_TEST_PATTERN]);
+	//if (test_mode)
+		//err = ov5693_write_table(priv,
+		//	mode_table[OV5693_MODE_TEST_PATTERN]);
 
 	return 0;
 
@@ -947,8 +960,8 @@ static int ov5693_stop_streaming(struct tegracam_device *tc_dev)
 	int err;
 
 	mutex_lock(&priv->streaming_lock);
-	err = ov5693_write_table(priv,
-		mode_table[OV5693_MODE_STOP_STREAM]);
+	err = 0;//ov5693_write_table(priv,
+		//mode_table[OV5693_MODE_STOP_STREAM]);
 	if (err) {
 		mutex_unlock(&priv->streaming_lock);
 		goto exit;
@@ -1232,7 +1245,10 @@ static int ov5693_probe(struct i2c_client *client,
 		ov5693_debugfs_remove(priv);
 		goto fail;
 	}
-
+	//err = ov5693_write_table(priv, mode_table[MODE_TI954_953]);
+        //if (err) {
+        //        printk("table write error\n");
+        //}
 	dev_dbg(dev, "Detected OV5693 sensor\n");
 
 	return 0;
@@ -1258,7 +1274,7 @@ ov5693_remove(struct i2c_client *client)
 	tegracam_v4l2subdev_unregister(priv->tc_dev);
 	ov5693_power_put(priv->tc_dev);
 	tegracam_device_unregister(priv->tc_dev);
-	ov5693_eeprom_device_release(priv);
+	//ov5693_eeprom_device_release(priv);
 
 	mutex_destroy(&priv->streaming_lock);
 
diff --git a/kernel/nvidia/drivers/media/platform/tegra/Makefile b/kernel/nvidia/drivers/media/platform/tegra/Makefile
index 45b1d2632..6af67944a 100644
--- a/kernel/nvidia/drivers/media/platform/tegra/Makefile
+++ b/kernel/nvidia/drivers/media/platform/tegra/Makefile
@@ -7,7 +7,8 @@ GCOV_PROFILE := y
 obj-$(CONFIG_VIDEO_CAMERA)	+= camera/
 obj-$(CONFIG_VIDEO_TEGRA_VI)	+= vi/
 obj-$(CONFIG_VIDEO_CAMERA)	+= regmap_util.o
-obj-$(CONFIG_VIDEO_TEGRA_VI_TPG) += tpg/
+#obj-$(CONFIG_VIDEO_TEGRA_VI_TPG) += tpg/
+obj-y += tpg/
 obj-$(CONFIG_TEGRA_MIPI_CAL)	+= mipical/
 obj-$(CONFIG_VIDEO_ISC)		+= isc/
 obj-$(CONFIG_VIDEO_CDI)		+= cdi/
diff --git a/kernel/nvidia/drivers/media/platform/tegra/camera/camera_common.c b/kernel/nvidia/drivers/media/platform/tegra/camera/camera_common.c
index 2b0b341b0..ace1af341 100644
--- a/kernel/nvidia/drivers/media/platform/tegra/camera/camera_common.c
+++ b/kernel/nvidia/drivers/media/platform/tegra/camera/camera_common.c
@@ -441,6 +441,7 @@ void camera_common_create_debugfs(
 		struct camera_common_data *s_data,
 		const char *name)
 {
+#if 0
 	struct dentry *err;
 	struct device *dev = s_data->dev;
 
@@ -462,6 +463,8 @@ void camera_common_create_debugfs(
 remove_debugfs:
 	dev_err(dev, "couldn't create debugfs\n");
 	camera_common_remove_debugfs(s_data);
+#endif
+	return;
 }
 EXPORT_SYMBOL_GPL(camera_common_create_debugfs);
 
diff --git a/kernel/nvidia/drivers/media/platform/tegra/camera/sensor_common.c b/kernel/nvidia/drivers/media/platform/tegra/camera/sensor_common.c
index d50b22e49..cb6753b50 100644
--- a/kernel/nvidia/drivers/media/platform/tegra/camera/sensor_common.c
+++ b/kernel/nvidia/drivers/media/platform/tegra/camera/sensor_common.c
@@ -265,6 +265,20 @@ static int extract_pixel_format(
 		*format = V4L2_PIX_FMT_XBGGR10P;
 	else if (strncmp(pixel_t, "bayer_xrggb10p", size) == 0)
 		*format = V4L2_PIX_FMT_XRGGB10P;
+        else if (strncmp(pixel_t, "yuv_yuyv8", size) == 0){
+                *format = V4L2_PIX_FMT_YUYV;
+	}
+        else if (strncmp(pixel_t, "yuv_yuyv10", size) == 0){
+                *format = V4L2_PIX_FMT_YUYV;
+	}
+	else if (strncmp(pixel_t, "yuv_uyvy16", size) == 0)  
+                *format = V4L2_PIX_FMT_UYVY;
+        else if (strncmp(pixel_t, "yuv_uyvy8", size) == 0){
+                *format = V4L2_PIX_FMT_UYVY;
+	}
+        else if (strncmp(pixel_t, "yuv_uyvy10", size) == 0){
+                *format = V4L2_PIX_FMT_UYVY;
+	}
 	else if (strncmp(pixel_t, "yuv_yuyv16", size) == 0)
 		*format = V4L2_PIX_FMT_YUYV;
 	else if (strncmp(pixel_t, "yuv_yvyu16", size) == 0)
@@ -273,6 +287,9 @@ static int extract_pixel_format(
 		*format = V4L2_PIX_FMT_UYVY;
 	else if (strncmp(pixel_t, "yuv_vyuy16", size) == 0)
 		*format = V4L2_PIX_FMT_VYUY;
+	else if (strncmp(pixel_t, "bayer_rgb88824", size) == 0){
+        	*format = V4L2_PIX_FMT_RGB24;
+	}
 	else {
 		pr_err("%s: Need to extend format%s\n", __func__, pixel_t);
 		return -EINVAL;
diff --git a/kernel/nvidia/drivers/media/platform/tegra/camera/tegracam_v4l2.c b/kernel/nvidia/drivers/media/platform/tegra/camera/tegracam_v4l2.c
index 8d0d16ca5..3003f32c9 100644
--- a/kernel/nvidia/drivers/media/platform/tegra/camera/tegracam_v4l2.c
+++ b/kernel/nvidia/drivers/media/platform/tegra/camera/tegracam_v4l2.c
@@ -59,13 +59,14 @@ static int v4l2sd_stream(struct v4l2_subdev *sd, int enable)
 		}
 
 		/* update control ranges based on mode settings*/
+#if 0
 		err = tegracam_init_ctrl_ranges_by_mode(
 			s_data->tegracam_ctrl_hdl, (u32) s_data->mode);
 		if (err) {
 			dev_err(&client->dev, "Error updating control ranges\n");
 			goto error;
 		}
-
+#endif
 		if (s_data->override_enable) {
 			err = tegracam_ctrl_set_overrides(
 					s_data->tegracam_ctrl_hdl);
@@ -144,12 +145,12 @@ static int v4l2sd_set_fmt(struct v4l2_subdev *sd,
 		struct v4l2_subdev_pad_config *cfg,
 	struct v4l2_subdev_format *format)
 {
-	struct i2c_client *client = v4l2_get_subdevdata(sd);
-	struct camera_common_data *s_data = to_camera_common_data(&client->dev);
+//	struct i2c_client *client = v4l2_get_subdevdata(sd);
+//	struct camera_common_data *s_data = to_camera_common_data(&client->dev);
 	int ret;
 
-	if (!s_data)
-		return -EINVAL;
+//	if (!s_data)
+//		return -EINVAL;
 
 	if (format->which == V4L2_SUBDEV_FORMAT_TRY)
 		ret = camera_common_try_fmt(sd, &format->format);
@@ -157,6 +158,7 @@ static int v4l2sd_set_fmt(struct v4l2_subdev *sd,
 		ret = camera_common_s_fmt(sd, &format->format);
 
 		if (ret == 0) {
+#if 0
 			/* update control ranges based on mode settings*/
 			ret = tegracam_init_ctrl_ranges_by_mode(
 				s_data->tegracam_ctrl_hdl, (u32) s_data->mode);
@@ -164,6 +166,7 @@ static int v4l2sd_set_fmt(struct v4l2_subdev *sd,
 				dev_err(&client->dev, "Error updating control ranges %d\n", ret);
 				return ret;
 			}
+#endif
 		}
 	}
 
diff --git a/kernel/nvidia/drivers/media/platform/tegra/camera/vi/channel.c b/kernel/nvidia/drivers/media/platform/tegra/camera/vi/channel.c
index 6c978d0d4..4b9c395bf 100644
--- a/kernel/nvidia/drivers/media/platform/tegra/camera/vi/channel.c
+++ b/kernel/nvidia/drivers/media/platform/tegra/camera/vi/channel.c
@@ -602,6 +602,7 @@ void tegra_channel_ring_buffer(struct tegra_channel *chan,
 	} else {
 		/* TODO: granular time code information */
 		vb->timecode.seconds = ts->tv_sec;
+		vb->vb2_buf.timestamp = timespec64_to_ns(ts);
 	}
 
 	/* release buffer N at N+2 frame start event */
diff --git a/kernel/nvidia/drivers/media/platform/tegra/tpg/Makefile b/kernel/nvidia/drivers/media/platform/tegra/tpg/Makefile
index e4cebf527..606f0f91e 100644
--- a/kernel/nvidia/drivers/media/platform/tegra/tpg/Makefile
+++ b/kernel/nvidia/drivers/media/platform/tegra/tpg/Makefile
@@ -4,17 +4,18 @@ ccflags-y += -I$(srctree.nvidia)/drivers/media/platform/tegra
 ccflags-y += -I$(srctree.nvidia)/drivers/video/tegra/host
 ccflags-y += -Werror
 
-ifneq ($(filter y,$(CONFIG_ARCH_TEGRA_18x_SOC) $(CONFIG_ARCH_TEGRA_186_SOC)),)
-nvhost-vi-tpg-objs += tpg_t18x.o
-else
-nvhost-vi-tpg-objs += tpg_t21x.o
-endif
+#ifneq ($(filter y,$(CONFIG_ARCH_TEGRA_18x_SOC) $(CONFIG_ARCH_TEGRA_186_SOC)),)
+#nvhost-vi-tpg-objs += tpg_t18x.o
+#else
+#nvhost-vi-tpg-objs += tpg_t21x.o
+#endif
 
-ifneq ($(filter y,$(CONFIG_ARCH_TEGRA_19x_SOC) $(CONFIG_ARCH_TEGRA_194_SOC)),)
-nvhost-vi-tpg-t19x-objs += tpg_t19x.o
-endif
+#ifneq ($(filter y,$(CONFIG_ARCH_TEGRA_19x_SOC) $(CONFIG_ARCH_TEGRA_194_SOC)),)
+#nvhost-vi-tpg-t19x-objs += tpg_t19x.o
+#endif
 
-obj-$(CONFIG_VIDEO_TEGRA_VI_TPG) += nvhost-vi-tpg.o
-ifneq ($(filter y,$(CONFIG_ARCH_TEGRA_19x_SOC) $(CONFIG_ARCH_TEGRA_194_SOC)),)
-obj-$(CONFIG_VIDEO_TEGRA_VI_TPG) += nvhost-vi-tpg-t19x.o
-endif
+#obj-$(CONFIG_VIDEO_TEGRA_VI_TPG) += nvhost-vi-tpg.o
+#ifneq ($(filter y,$(CONFIG_ARCH_TEGRA_19x_SOC) $(CONFIG_ARCH_TEGRA_194_SOC)),)
+#obj-$(CONFIG_VIDEO_TEGRA_VI_TPG) += nvhost-vi-tpg-t19x.o
+#endif
+obj-y += tpg_t19x.o
